package com.sf.day16.homework;

import org.junit.Test;

import java.util.Comparator;
import java.util.Set;
import java.util.TreeSet;

public class Student2 {
    /**
     * 学生姓名
     */
    private String name;
    /**
     * 学生年龄
     */
    private int age;
    /**
     * 学生成绩
     */
    private int score;

    public Student2() {
    }

    public Student2(String name, int age, int score) {
        this.name = name;
        this.age = age;
        this.score = score;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    public int getScore() {
        return score;
    }

    public void setScore(int score) {
        this.score = score;
    }

    @Override
    public String toString() {
        return "name='" + name +
                " age=" + age +
                " score=" + score;
    }

    public static void main(String[] args) {
        //Comparator方式接口对以上同学的成绩做降序排序

        //创建TreeSet集合对象
        Set<Student> treeSet = new TreeSet<Student>(new Comparator<Student>() {
            @Override
            public int compare(Student o1, Student o2) {
                int num = o1.getScore() - o2.getScore();
                int num1 = num == 0 ? o1.getAge() - o2.getAge() : num;
                int num2 = num1 == 0 ? o1.getName().compareTo(o2.getName()) : num1;
                return num2;
            }
        });

        //创建学生对象
        treeSet.add(new Student("Tom",20,90));
        treeSet.add(new Student("Jerry",22,95));
        treeSet.add(new Student("John",20,100));
        treeSet.add(new Student("Lily",22,100));
        treeSet.add(new Student("Lucy",22,90));
        treeSet.add(new Student("Kevin",22,90));

        //遍历数组
        for (Student student : treeSet){
            System.out.println(student);
        }

    }
}
